#include <allegro.h>
#include <stdlib.h>

#include <vector>
#include <iostream>

// Using a C library!
#include <stdio.h>

using namespace std;

#include "common.h"
#include "playerinfo.h"
#include "ui.h"
#include "data.h"
#include "items.h"
#include "classes.h"
#include "manager.h"

// ui.cpp

static void uibuy(int item);

static DIALOG dlgLevelStart[] =
{
/* (dialog proc)	(x)	(y)	(w)	(h)	(fg),(bg)	(key)	(flags)	(d1)	(d2)	(dp),(dp2),(dp3) */
{ d_clear_proc,		0,	0,	640,	480,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_box_proc,		0,	0,	640,	120,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_text_proc,		8,	8,	624,	104,	255,0,		0,	0,	0,	0,	(void *) "hi" ,NULL, NULL },
{ d_button_proc,	8,	400,	144,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Play",NULL, NULL },
{ d_button_proc,	160,	400,	144,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Buy Stuff",NULL, NULL },
{ d_button_proc,	320,	400,	144,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "End Game",NULL, NULL },
{ NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,      0,    NULL,             NULL, NULL  }
};

static FONT * nicefont;

void initui()
{
	nicefont = (FONT *) datafile[IMPACT18PTMONO_PCX].dat;
}

static void setcolours(DIALOG *dlg)
{
	for (int i=0; dlg[i].proc != NULL; i++) {
		dlg[i].fg = makecol(255,255,255); // makecol(255,255,255);
		dlg[i].bg = makecol(80,60,0);
		dlg[i].dp2 = nicefont;
	}
}

bool uistartlevel()
{
	char title [80];
	sprintf(title, "Entering level %d",playerinfo.level);
	setcolours(dlgLevelStart);
	dlgLevelStart[2].dp = title;
	int res;
	do {
		res = do_dialog(dlgLevelStart,3);
		if (res == 3) return true;
		if (res == 5) return false;
		if (res == 4)
			uishop();
	} while (res != -1);
	return true;

}

static DIALOG dlgShop[] =
{
/* (dialog proc)	(x)	(y)	(w)	(h)	(fg),(bg)	(key)	(flags)	(d1)	(d2)	(dp),(dp2),(dp3) */
{ d_clear_proc,		0,	0,	640,	480,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_box_proc,		0,	0,	640,	120,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_text_proc,		8,	8,	424,	104,	255,0,		0,	0,	0,	0,
	(void *) "Honest Ed's spacefaring Ltd" ,NULL, NULL },
// Current money
{ d_text_proc,		432,	8,	200,	104,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_button_proc,	8,	400,	116,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Play",NULL, NULL },
{ d_button_proc,	128,	400,	120,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Prev",NULL, NULL },
{ d_button_proc,	256,	400,	120,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Next",NULL, NULL },
{ d_button_proc,	384,	400,	120,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Buy",NULL, NULL },
{ d_rtext_proc,		8,	128,	80,	20,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Item:" ,
NULL,NULL },
{ d_text_proc,		96,	128,	536,	20,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ d_rtext_proc,		8,	158,	80,	20,	255,0,		0,	0,	0,	0,	(void *) "Price:" ,
NULL,NULL },
{ d_text_proc,		96,	158,	536,	20,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ d_rtext_proc,		8,	188,	80,	20,	255,0,		0,	0,	0,	0,	(void *) "Desc:" ,
NULL,NULL },
{ d_textbox_proc,	96,	188,	536,	150,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ d_rtext_proc,		8,	340,	80,	20,	255,0,		0,	0,	0,	0,	(void *) "Current:" ,
NULL,NULL },
{ d_text_proc,		96,	340,	536,	20,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,      0,    NULL,             NULL, NULL  }
};

void uishop()
{
	int shopitem = 0;
	setcolours(dlgShop);
	int res;
	do {
		ShipItemType it = shipitems[shopitem].type;
		int currentitem;
		if (it == ItemEngine) {
			currentitem = playerinfo.engine;
		} else {
			currentitem = playerinfo.weapon;
		}
		char * currentitemname = "None";
		for (int j=0; shipitems[j].type != EndOfItems; j++) {
			if ((shipitems[j].id == currentitem) &&
			    (shipitems[j].type == shipitems[shopitem].type))
			    currentitemname = shipitems[j].name;
		}
		char money[50];
		sprintf(money, "Money: $ %d", playerinfo.money);
		dlgShop[3].dp = (void *) money;
		char itemprice[50];
		sprintf(itemprice, "$ %d", shipitems[shopitem].price);
		dlgShop[9].dp = shipitems[shopitem].name;
		dlgShop[11].dp = (void *) itemprice;
		dlgShop[13].dp = shipitems[shopitem].description;
		dlgShop[13].dp2 = (void *) font;
		dlgShop[15].dp = currentitemname;
		res = do_dialog(dlgShop,4);
		if (res == 5) // Prev
		{
			if (shopitem>0)
				shopitem --;
		}
		if (res == 6)
		{
			if (shipitems[shopitem+1].type != EndOfItems) {
				shopitem ++;
			}
		}
		if (res == 7 )
			uibuy(shopitem);

	} while ((res != 4) && (res != -1));
}

static DIALOG dlgBuy[] =
{
/* (dialog proc)	(x)	(y)	(w)	(h)	(fg),(bg)	(key)	(flags)	(d1)	(d2)	(dp),(dp2),(dp3) */
{ d_clear_proc,		0,	0,	640,	480,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_box_proc,		0,	0,	640,	120,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_text_proc,		8,	8,	424,	104,	255,0,		0,	0,	0,	0,
	(void *) "Honest Ed's spacefaring Ltd" ,NULL, NULL },
{ d_button_proc,	8,	400,	116,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Continue",NULL, NULL },
{ d_rtext_proc,		8,	128,	80,	20,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Item:" ,
NULL,NULL },
{ d_text_proc,		96,	128,	536,	20,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ d_text_proc,		96,	158,	536,	20,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,      0,    NULL,             NULL, NULL  }
};

static void uibuy(int item)
{
	setcolours(dlgBuy);
	dlgBuy[5].dp = shipitems[item].name;
	int price = shipitems[item].price;
	char *msg = "Bought!";
	if (price > playerinfo.money) {
		msg = "Not enough cash";
	} else {
		if (shipitems[item].type == ItemEngine) {
			playerinfo.engine = shipitems[item].id;
		} else {
			playerinfo.weapon = shipitems[item].id;
		}
		playerinfo.money -= price;
	}
	dlgBuy[6].dp = msg;
	do_dialog(dlgBuy,3);
}

static DIALOG dlgComplete[] =
{
/* (dialog proc)	(x)	(y)	(w)	(h)	(fg),(bg)	(key)	(flags)	(d1)	(d2)	(dp),(dp2),(dp3) */
{ d_clear_proc,		0,	0,	640,	480,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_box_proc,		0,	0,	640,	120,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_text_proc,		8,	8,	424,	104,	255,0,		0,	0,	0,	0,
	(void *) "Level Complete" ,NULL, NULL },
{ d_button_proc,	8,	400,	116,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Continue",NULL, NULL },
{ d_rtext_proc,		8,	128,	160,	20,	255,0,		0,	D_EXIT,	0,	0,	(void *) "completion:" ,
NULL,NULL },
{ d_text_proc,		196,	128,	536,	20,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ d_rtext_proc,		8,	158,	160,	20,	255,0,		0,	0,	0,	0,	(void *) "Oxygen bonus:" ,
NULL,NULL },
{ d_text_proc,		196,	158,	536,	20,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ d_rtext_proc,		8,	188,	160,	20,	255,0,		0,	0,	0,	0,	(void *) "Hydrogen bonus:" ,
NULL,NULL },
{ d_text_proc,		196,	188,	536,	150,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ d_rtext_proc,		8,	218,	160,	20,	255,0,		0,	0,	0,	0,	(void *) "Ammo Bonus:" ,
NULL,NULL },
{ d_text_proc,		196,	218,	536,	20,	255,0,		0,	0,	0,	0,	NULL,NULL,NULL },
{ d_text_proc,		196,	248,	536,	20,	255,0,		0,	0,	0,	0,	(void *) "",NULL,NULL },
{ NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,      0,    NULL,             NULL, NULL  }
};

void uilevelcomplete()
{
	clear_keybuf();
	Ship * ship = (Ship *) playership;
	setcolours(dlgComplete);
	int completionbonus = (playerinfo.level * 20);
	int oxygenbonus = (int) (ship->oxygen * 20.0);
	int hydrogenbonus = (int) (ship->hydrogen * 20.0);
	int ammobonus = (int) (ship->ammo * 20.0);
	char completion[50];
	sprintf(completion, "$ %d", completionbonus);
	char oxygen[50];
	sprintf(oxygen,"$ %d",oxygenbonus);
	char hydrogen[50];
	sprintf(hydrogen,"$ %d", hydrogenbonus);
	char ammo[50];
	sprintf(ammo,"$ %d", ammobonus);
	dlgComplete[5].dp = (void *) completion;
	dlgComplete[7].dp = (void *) oxygen;
	dlgComplete[9].dp = (void *) hydrogen;
	dlgComplete[11].dp = (void *) ammo;
	int total = completionbonus + oxygenbonus + hydrogenbonus + ammobonus;
	playerinfo.money += total;
	playerinfo.score += total;
	const char * msg = (playerinfo.level == NumLevels) ?
		"You Won! (Sorry there is no outro!)" :
		"";
	dlgComplete[12].dp = (void *) msg;
	do_dialog(dlgComplete,3);
	// They may now start on the next level.
	if (playerinfo.level < NumLevels)
		playerinfo.maxstartlevel = playerinfo.level + 1;
}

static DIALOG dlgMainMenu[] =
{
/* (dialog proc)	(x)	(y)	(w)	(h)	(fg),(bg)	(key)	(flags)	(d1)	(d2)	(dp),(dp2),(dp3) */
{ d_clear_proc,		0,	120,	640,	480,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_bitmap_proc,	0,	0,	640,	120,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
{ d_text_proc,		8,	128,	624,	30,	255,0,		0,	0,	0,	0,	(void *) "Background" ,NULL, NULL },
{ d_textbox_proc,	8,	158,	624,	90,	255,0,		0,	0,	0,	0,
(void *) "Erm, on Mars Dr. Frankenstein has made some mutant jellies. And they took over the mines and stuff."
"Or some lame plot like that. you know the score :)" ,NULL, NULL },
{ d_text_proc,		8,	248,	624,	30,	255,0,		0,	0,	0,	0,
(void *) "How to Play" ,NULL, NULL },
{ d_textbox_proc,	8,	276,	624,	76,	255,0,		0,	0,	0,	0,
(void *) "The aim on each level is to reach the exit. The jellies may stop you doing that."
" Use the arrow keys to rotate your ship, the up arrow to fire the rocket, and the CTRL key to fire the acid gun. "
" Your ship runs on hydrogen and oxygen, pick these up by pressing SPACE when near to a tank."
" Tanks of acid are also available to recharge your ammo."
" To end the level, find the teleporter pad and hold down space for a couple of seconds.\n"
"You may start on any level you have reached before (this is not saved)"
 ,NULL, NULL },
{ d_button_proc,	8,	400,	144,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Play",NULL, NULL },
{ d_button_proc,	320,	400,	144,	76,	255,0,		0,	D_EXIT,	0,	0,	(void *) "Quit",NULL, NULL },
{ d_text_proc,		8,	360,	80,	30,	255,0,		0,	0,	0,	0,
(void *) "Start Level" ,NULL, NULL },
{ d_edit_proc,		188,	360,	80,	30,	255,0,		0,	0,	2,	0,(void *) "1" ,NULL, NULL },
{ NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,      0,    NULL,             NULL, NULL  }
};


bool uimainmenu()
{
	char startlevelbuf[10];
	sprintf(startlevelbuf,"%d", playerinfo.maxstartlevel);
	clear_keybuf();
	setcolours(dlgMainMenu);
	dlgMainMenu[1].dp = (void *) datafile[BANNER_TGA].dat;
	dlgMainMenu[9].dp = (void *) startlevelbuf;
	int res = do_dialog(dlgMainMenu,6);
	int startlevel = atoi(startlevelbuf);
	if ((startlevel >= 1) && (startlevel <= playerinfo.maxstartlevel))
		playerinfo.level = startlevel;
	else
		playerinfo.level = 1;
	return (res == 6);
}
